您的位置:首页 > 编程语言 > C#

LeetCode #1 Two Sum C# Solution

2016-04-03 14:00 549 查看
LeetCode #1 Problem

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,

return [0, 1].

基本上看到题第一反应都是一个O(N^2)的双重循环,但是在大数据下必然会TLE,所以考虑其他算法。

可以想到,寻找两个数相加得到target可以转换为target减去ans[0]然后在nums[]中寻找ans[1]是否存在。同时,哈希表拥有查找效率为O(1)的优势,于是这样一重循环就可以找到答案了。

C# Code
public int[] TwoSum(int[] nums, int target)
{
Hashtable ht = new Hashtable();
List<int> list = new List<int>();
list = nums.ToList<int>();
int i = 0;
foreach (int num in list)
{
if (!ht.Contains(num)) ht.Add(num,i);
i++;
}
i = 0;
foreach (int num in list)
{
int temp = target - num;
if (ht.Contains(temp)&&i!=(int)ht[temp])
{
int[] ans = new int[2];
ans[0] = i;
ans[1] = (int)ht[temp];
return ans;
}
i++;
}
return null;
}


内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: